/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /local/robotpkg/var/tmp/robotpkg/wip/infuse-msgs-ros/work/infuse-msgs-ros-0.1.0/msg/asn1_bitstream.msg
 *
 */


#ifndef INFUSE_MSGS_MESSAGE_ASN1_BITSTREAM_H
#define INFUSE_MSGS_MESSAGE_ASN1_BITSTREAM_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Header.h>

namespace infuse_msgs
{
template <class ContainerAllocator>
struct asn1_bitstream_
{
  typedef asn1_bitstream_<ContainerAllocator> Type;

  asn1_bitstream_()
    : header()
    , type()
    , serialization_method(0)
    , data()  {
    }
  asn1_bitstream_(const ContainerAllocator& _alloc)
    : header(_alloc)
    , type(_alloc)
    , serialization_method(0)
    , data(_alloc)  {
    }



   typedef  ::std_msgs::Header_<ContainerAllocator>  _header_type;
  _header_type header;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _type_type;
  _type_type type;

   typedef uint8_t _serialization_method_type;
  _serialization_method_type serialization_method;

   typedef std::vector<uint8_t, typename ContainerAllocator::template rebind<uint8_t>::other >  _data_type;
  _data_type data;




  typedef boost::shared_ptr< ::infuse_msgs::asn1_bitstream_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::infuse_msgs::asn1_bitstream_<ContainerAllocator> const> ConstPtr;

}; // struct asn1_bitstream_

typedef ::infuse_msgs::asn1_bitstream_<std::allocator<void> > asn1_bitstream;

typedef boost::shared_ptr< ::infuse_msgs::asn1_bitstream > asn1_bitstreamPtr;
typedef boost::shared_ptr< ::infuse_msgs::asn1_bitstream const> asn1_bitstreamConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::infuse_msgs::asn1_bitstream_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::infuse_msgs::asn1_bitstream_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace infuse_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': True}
// {'infuse_msgs': ['/local/robotpkg/var/tmp/robotpkg/wip/infuse-msgs-ros/work/infuse-msgs-ros-0.1.0/msg'], 'std_msgs': ['/opt/openrobots/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::infuse_msgs::asn1_bitstream_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::infuse_msgs::asn1_bitstream_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::infuse_msgs::asn1_bitstream_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::infuse_msgs::asn1_bitstream_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::infuse_msgs::asn1_bitstream_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::infuse_msgs::asn1_bitstream_<ContainerAllocator> const>
  : TrueType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::infuse_msgs::asn1_bitstream_<ContainerAllocator> >
{
  static const char* value()
  {
    return "2bdf6d807f5ec0c1dcac26c88cebc0ac";
  }

  static const char* value(const ::infuse_msgs::asn1_bitstream_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x2bdf6d807f5ec0c1ULL;
  static const uint64_t static_value2 = 0xdcac26c88cebc0acULL;
};

template<class ContainerAllocator>
struct DataType< ::infuse_msgs::asn1_bitstream_<ContainerAllocator> >
{
  static const char* value()
  {
    return "infuse_msgs/asn1_bitstream";
  }

  static const char* value(const ::infuse_msgs::asn1_bitstream_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::infuse_msgs::asn1_bitstream_<ContainerAllocator> >
{
  static const char* value()
  {
    return "std_msgs/Header header\n\
string type\n\
uint8 serialization_method\n\
uint8[] data \n\
\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')\n\
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
";
  }

  static const char* value(const ::infuse_msgs::asn1_bitstream_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::infuse_msgs::asn1_bitstream_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.header);
      stream.next(m.type);
      stream.next(m.serialization_method);
      stream.next(m.data);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct asn1_bitstream_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::infuse_msgs::asn1_bitstream_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::infuse_msgs::asn1_bitstream_<ContainerAllocator>& v)
  {
    s << indent << "header: ";
    s << std::endl;
    Printer< ::std_msgs::Header_<ContainerAllocator> >::stream(s, indent + "  ", v.header);
    s << indent << "type: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.type);
    s << indent << "serialization_method: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.serialization_method);
    s << indent << "data[]" << std::endl;
    for (size_t i = 0; i < v.data.size(); ++i)
    {
      s << indent << "  data[" << i << "]: ";
      Printer<uint8_t>::stream(s, indent + "  ", v.data[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // INFUSE_MSGS_MESSAGE_ASN1_BITSTREAM_H
